#ifndef DEBUGPLATFORM_H_
#define DEBUGPLATFORM_H_ 1
#ifdef __cplusplus
 extern "C" {
#endif 
#include <stdint.h>

#include "Errors.h"

/** Debug input/output channel **/
void DebugInit();
void DebugPrint(const char *format, ...);
void DebugOut(char c);
char DebugIn();

/** Assert error and pretty print error message **/
#define ERRORprint() if (IsError) {DebugPrint("ERROR: %s in %s() %s:%i, reported from %s() %s:%i\n", errorMsg, errorFunc ? errorFunc : "UNK", errorFile ? errorFile : "UNK", errorLine, __func__, __FILE__, __LINE__);} else {DebugPrint("No Error\n");}
#define ERRORassert() if (IsError) {ERRORprint(); assert(0);}

#ifdef __cplusplus
}
#endif 
#endif //DEBUGPLATFORM_H_

