#ifndef INPUTPLATFORM_H_
#define INPUTPLATFORM_H_ 1
#ifdef __cplusplus
 extern "C" {
#endif 
#include <stdint.h>

/** Input
 * Simple input/output model. **/
typedef enum {
  LED0 = 0,
  LED1,
  BUTTON0,
  BUTTON1
} InputId;

void InputInit();
uint8_t InputGetState(InputId idx);

/** Roughly based on SDL_KeyboardEvent **/
typedef struct {
  uint16_t scancode; // Platform-specific, optional/internal?
  uint16_t keysym; // Platform-specific, optional/internal?
  char isRelease; // 0 for "Make" (down), 1 for "Break" up)
  uint32_t ucs4; // Unicode symbol, if any, else 0x0. Low order 7 bits are ASCII if high order 0.  Mostly for future.
} KeyEvent;

/** Read next key from keyboard, if available. 
 *  Returns 1 if event was returned, 0 if no events queued **/
char ReadKey(KeyEvent *outEvent); 

#ifdef __cplusplus
}
#endif 
#endif //INPUTPLATFORM_H_
