#include "WikiText.h"
#include <stdio.h>

int main(int argc, char **argv) {
  char buf[512];
  int sz=0;
  FILE *fin=stdin;
  if (argc == 2) {
    fin = fopen(argv[1],"rb");
    if (!fin) {
      fprintf(stderr,"ERROR: Could not open %s\n",argv[1]);
      return -1;
    }
  }
  do {
    sz = fread(buf, 1, 512, fin);
    if (sz) {
#if 1
      printf("ORIG: ");
      for (int i=0; i<sz; ++i)
        putc(buf[i], stdout);
      putc('\n',stdout);
      const int tokensLen=128;
      WToken tokens[tokensLen];
      int n = WTTokenize(buf, sz, tokens, tokensLen);
      WToken *tokensEnd = tokens + n;
      WToken *curtok=&tokens[0];
      WTPrintDebug(tokens, n, 1);
#if 0
      for (; curtok; curtok = WTNextSibling(curtok, tokensEnd - curtok)) {
        for (int i=0; i<curtok->strLen; ++i)
          putc(curtok->str[i], stdout);
        putc('\n',stdout);
      }
#endif
#else
      WToken tok;
      int pos=0;
      int level=0;
      while (1) {
        if (pos >= 512) break;
        tok = WikiTextNextToken(buf + pos, sz - pos);
        if (tok.strLen == 0) break;
        if (tok.type == WT_OPEN) 
          ++level;
        if (level == 0) {
          for (int i=0; i<tok.strLen; ++i)
            putc(buf[pos+i], stdout);
          putc('\n', stdout);
        } 
        if (tok.type == WT_CLOSE) 
          --level;
        pos += tok.strLen;
      }
#endif
    }
    return 0; // DEBUG
  } while (sz && !feof(fin));
}
