#ifndef BLITTER_H_
#define BLITTER_H_ 1

#include <stdint.h>

typedef struct {
  unsigned char *p; // pointer to start of raster
  uint16_t m; // modulo (a negative is modulo 2**16)
} Raster;

typedef uint8_t TruthTable;

typedef uint8_t RasterIndex;
#define RasterListLen 256
extern Raster rasterList[RasterListLen];

typedef struct {
  Raster reg[4]; // A,B,C,D
  TruthTable tt; // Unimplemented
  uint8_t shift[2]; // rotate for reg A and B
  uint16_t w,h; // blit size width (bytes) and height (rows)

  /* Working Variables */
  uint16_t cycle; // current cycle for current blit op
  uint16_t cyclesLeft;
  unsigned char *pA,*pB,*pC,*pD;
} BlitterMachine;

extern BlitterMachine blit;



#define BLIT_OPCODE(sz, cmd, reg) \
  ((sz << 7) | (cmd << 4) | (reg))

#endif //BLITTER_H_
