#include <avr/io.h>
#include <stdio.h>
#include <string.h>

#define FOSC 16000000 // Clock Speed
#define BAUD 57600
#define MYUBRR FOSC/16/BAUD-1

void USART_Init( unsigned int ubrr)
{
  /*Set baud rate */
  UBRR0H = (unsigned char)(ubrr>>8);
  UBRR0L = (unsigned char)ubrr;
  /* Enable receiver and transmitter */
    UCSR0B = (1<<RXEN0)|(1<<TXEN0);
  /* Set frame format: 8data, 2stop bit */
  UCSR0C = (1<<USBS0)|(3<<UCSZ00);
}

void USART_Transmit( unsigned char data ) {
  /* Wait for empty transmit buffer */
  while ( !( UCSR0A & (1<<UDRE0)) )
    ;
  /* Put data into buffer, sends the data */
  UDR0 = data;
}

int main(int argc, char **argv) {
  USART_Init(MYUBRR);
  char *hello="hello world";
  int k=0;
  while (1) {
    for (int i=0; i<strlen(hello); ++i) {
      USART_Transmit(hello[i]);
    }
    USART_Transmit('!');
    USART_Transmit('0');//+(k % 10));
    USART_Transmit('0'+k);
    USART_Transmit('$');//+(k % 10));
    k++;
    if (k==10) k=0;
    USART_Transmit('\r');
    USART_Transmit('\n');
  }
}

