#include <avr\io.h>

#include <avr\interrupt.h>

#include <avr\iom8.h>

#define OCP PINB1

/*This example demonstrates how 1kHz signal

can be generated using timer and compare match interrupt

if F_CPU=1MHz, then 1 clk is 1us. For 1kHz signal

there is 1000clk=1000us. For toggling ponts = 500clk

*/

//Output compare ISR

ISR(TIMER1_COMPA_vect){

  OCR1A+=500;

}

int main(void) {

//Set PORTB1 pin as output

DDRB=(1<<OCP);

//Output compare toggles OC1A pin

TCCR1A=0x40;

//start timer without prescaler

TCCR1B=0x01;

//enable output compare interrupt for OCR1A

TIMSK=0x10;

 

sei();

    for (;;) {

/* loop forever timer does the job*/

 

    }

}


