
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>  
#include <avr/sleep.h>

//include "uCmorse/uCmorse.h"
#include "Platform.h"
#include "Glyphs.h"
#include "Errors.h"

#if 0
#include "data/fonts_8x8_2.pic.inc"
#else
#include "data/iso8859-1.c"
#endif

#include "z816-defines.h"

void sounder(int onOrOff, int msec) {
#if 0
  DDRD  |= 1 << PD4;
  if (onOrOff)
    PORTD &= ~(1 << PD4); // led on
  else 
    PORTD |= 1 << PD4; // led off
  _delay_ms((float)msec);
  PORTD |= 1 << PD4; // off at end
#endif
}

void PlatformInit() {
	//stop timers
	TCCR1B=0;

	//set ports
	DDRC=0xff; //video dac
	DDRB=0xff; //h-sync for ad725
	SYNC_PORT=(1<<SYNC_PIN)|(1<<VIDEOCE_PIN); //set sync & chip enable line to hi

  //  16-BIT TIMER 1 HANDLING VIDEO INTERRUPTS
#if 1
  /*
   *    * Run timer 1 in CTC mode, prescaler 64.
   *       */
  TCCR1B = _BV(WGM12) | _BV(CS10);
  //TCCR1B = _BV(WGM12) | _BV(CS12)| _BV(CS10);
  OCR1A = 0;
  /*
   *    * Compare match 1A interrupts.
   *       */
  TIMSK1 |= _BV(OCIE1A);

  OCR1A = (1 << 14); // the interrupt will hit this soon enough
#endif
	
  //set clock divider counter for AD725 on TIMER0
	//outputs 14.31818Mhz (4FSC)
	TCCR0A=(1<<COM0A0)+(1<<WGM01); //toggle on compare match + CTC
	OCR0A=0; //divide main clock by 2
	TCCR0B=(1<<CS00); //enable timer, no pre-scaler

	SYNC_PORT=(1<<SYNC_PIN)|(1<<VIDEOCE_PIN); //set sync & chip enable line to hi
  sei();

}

void ScrClear() {}
void VideoUpdate() {}

int main() {
  //tapString("S ");
  PlatformInit();
  //tapString("GO");
#if 1
  if (IsError)
    while (1)
      ;//tapString("SOS 1 ");

  SetGlyphMap((const uint8_t*) font_bitpacked, FONT_TILESET_SIZE, 8, 16);
  ClearCells();
  ScrClear();

  while (1) {
    const char *s="HELLO WORLD";
    for (int j=0; j<10; ++j) {
      do {
        AddGlyph(0, 8*j, 'A' + j, 1, 0);
        if (IsError) break;
        for (int i=0; s[i] != 0x0; ++i) {
          AddGlyph( 10 + (8+j)*i, (10+j)*j, s[i], 1, 0);
          if (IsError) break;
        }
      } while(0);
      if (IsError) {
        //tapString("SOS 2 2 OK");
        ClearError();
      }
    }
    VideoUpdate();
  }
#endif
  //while (1)
    //test_delay();
  //while (1)
   // run_timetable();
  for (int i=0; 1; ++i) {
    char c[2];
    c[1] = (i % 42) + '0';
    c[2] = 0x0;
//    tapString(c);
//    tapString("          ");
  }
}
