#include <avr/io.h>

.global assemblyFunc
.global delay_cycles
.global delay_ms_asm

delay_cycles:
1:
  sbiw r24,1  ;2
  brcc 1b  ;1/2
  ret

;; r24:25 
delay_ms_asm:
  push XL
  push XH
1:
  ldi XL, lo8(F_CPU/1000/4)
  ldi XH, hi8(F_CPU/1000/4)
2:
    sbiw XL, 4
    brcc 2b
  sbiw r24, 1
  brcc 1b
  pop XH
  pop XL
  ret

.section .text

;;; Taps "E" + arg + count, returns count
assemblyFunc:
  mov r29, r24 ; Stash Passed argument
13:
  ldi r24, 'E'
  clr r25
  call tapChar

  ; tap arg
  mov r24, r29
  clr r25
  call tapChar

.section .data
count_af:
  .byte '0'
.section .text
  lds r24, count_af
  inc r24
  sts count_af, r24
  clr r25
  call tapChar

  ; Return Value
  lds r24, count_af
  clr r25
  ret

